/**
 * Copyright 2010 Trustees of the University of Pennsylvania Licensed under the
 * Educational Community License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License. You may
 * obtain a copy of the License at
 *
 * http://www.osedu.org/licenses/ECL-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS"
 * BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */
package metridoc.dsl

import metridoc.extension.ExtensionRunner

/**
 * Created by IntelliJ IDEA.
 * User: tbarker
 * Date: 4/3/11
 * Time: 4:22 PM
 * To change this template use File | Settings | File Templates.
 */
class JobBuilder {

    def JobManager manager

    private JobBuilder() {}

    def static JobBuilder load(String... jobFiles) {
        def builder = new JobBuilder()
        builder.getJobManager().parseJobs jobFiles
        return builder
    }

    def JobManager getJobManager() {
        if(manager == null) {
            manager = ExtensionRunner.extensionRunner.jobsRunner
        }

        return manager
    }

    def void run(String... jobs) {
        getJobManager().jobRunner.runJobs jobs
    }

    def static void run(String jobName, Closure closure) {
        def builder = new JobBuilder()
        def jobManager = builder.getJobManager()
        jobManager.loadJobs closure
        jobManager.runJob jobName
        jobManager.stop()
    }
}
